function X=recover_curve(Z,n2,K)

N=length(Z)/n2-2;
% K = number of (internal) points where the curve is evaluated
X=zeros(n2,K+2);
% endpoints:
X(:,1)=Z(1:n2);
X(:,end)=Z(n2+1:2*n2);
D=X(:,end)-X(:,1);
% evaluate intermediate points:
T=1/(K+1); % time interval
for j=1:K
    t=j*T;
    X(:,j+1)=X(:,1)+Z(2*n2+1:3*n2).*D*t; % linear part
    for i=1:N-1
        X(:,j+1)=X(:,j+1)+Z((i+2)*n2+1:(i+3)*n2)*sin(i*pi*t);
    end
end